// Grafting is the process of joining two plants together 
//(an upper portion and a lower portion) to grow as one. 
//The upper portion of the plant is known as the scion, 
//which is attached to the lower portion known as the rootstock.

//rs -- rootstock, sc -- scion
#pragma once

#include "data_def_api.h"
using namespace std;

//GCV_DEBUGÿһͼмͼƬʾopencvسִУڲ
// #define GCV_DEBUG
// export 
#define GCV_EXPORTS


#ifdef GCV_EXPORTS
#define GCV_API __declspec(dllexport)
#else
#define GCV_API __declspec(dllimport)
#endif


#ifdef __cplusplus
extern "C"
{
#endif

namespace graft_cv
{
//1 log·
GCV_API	int cv_set_logpath(char*lpath);

//2 logȼ
GCV_API	int cv_set_loglevel(int lev);// 0-debug, 1-info, 2-warning, 3-error

//3 Ƿ洢ͼƬ洢·configureļУtrue--棬false--
GCV_API int cv_init_image_saver();

//4 ʼļʼyml
//  أ 0-  1- ļ 
GCV_API int cv_init(char*conf_file);


//5 ʼͨConfigParamṹֱӸֵò(ڴ)
GCV_API void cv_set_param(ConfigParam&);
GCV_API int cv_set_param_from_file(char*conf_file);

//6 ӿ˳ǰͷ
GCV_API int cv_release();

//7 ȡǰļ·char*Ҫռ㹻ڲûмǷԽ
GCV_API void cv_get_conf_file(char*);

//8 浽ļУǣ
GCV_API void cv_save_param(char* conf_file/*=0*/);

//9 ȡǰò
GCV_API void cv_get_param(ConfigParam&);

//10 ȡǰ汾ţchar*Ҫռ㹻ڲûмǷԽ
GCV_API void get_version(char* buf);


//11 ѿ,3dƣҵץȡλã ľ
//  
//  룺 points ---      룬 ָƵָ룬Ϊ3ֵһ飬ṹ[pt0.x, pt0.y, pt0.z, pt1.x, pt1.y,pt1.z], ʱ4ֵһ飨Ӳɼ豸
//         pixel_size ---  룬һƵάȣһ34
//         pt_size-------- 룬 Ϊ2
//         posinfo ------- 
//				double rs_grab_x;		//ľץȡλx
//				double rs_grab_y;		//ľץȡλy
//				double rs_grab_z;		//ľץȡλz
//              double rs_fork_x;       //ľ羥λx
//              double rs_fork_y;       //ľ羥λy
//              double rs_fork_z;       //ľ羥λz
//				double rs_width;		//Ŀȣֱ
//				double rs_tortuosity;	//ȣ뾥룬
//				double rs_count;		//ǰһŹж
//              ImgInfo* pp_images[5];  //صĴͼƬ
//
//         fn ------------ 룬 pointsָ0fnʱȡļеݣڲԣ֧plyʽ
//
//  أ 0-  - ʧ
GCV_API int sola_grab_point_rs(float* points, int pixel_size, int pt_size, PositionInfo& posinfo, const char* fn = 0);

//12 ѿ,3dƣҵץȡλã 
//  
//  룺 points ---      룬 ָƵָ룬Ϊ3ֵһ飬ṹ[pt0.x, pt0.y, pt0.z, pt1.x, pt1.y,pt1.z], ʱ4ֵһ飨Ӳɼ豸
//         pixel_size ---  룬һƵάȣһ34
//         pt_size-------- 룬 Ϊ2
//         posinfo ------- 
//				double sc_grab_x;		//ץȡλx
//				double sc_grab_y;		//ץȡλy
//				double sc_grab_z;		//ץȡλz
//				double sc_width;		//Ŀȣֱ
//				double sc_tortuosity;	//ȣ뾥룬
//				double sc_count;		//ǰһŹж
//              ImgInfo* pp_images[5];  //صĴͼƬ
//
//         fn ------------ 룬 pointsָ0fnʱȡļеݣڲԣ֧plyʽ
//
//  أ 0-  - ʧ
GCV_API int sola_grab_point_sc(float* points, int pixel_size, int pt_size, PositionInfo& posinfo, const char* fn = 0);


//13 3d̸궨ܣͨĵƣ̸ƣʶϵĽ㣬
GCV_API int chessboard_calibration(float* points, int pixel_size, int pt_size, PositionInfo& posinfo, const char* fn = 0);

};//namespace graft_cv

#ifdef __cplusplus
}
#endif